/* Jednoduch metody pro vstup celch a relnch sel
// Verze s metodou bool ti(ref int) a bool ti(ref double)

  Peklad:
  
csc /t:library VV.cs

nebo

csc /target:library VV.cs
  
Vytvo se dynamick knihovna VV.dll  
*/

using System;
using System.Text;

public class EOFException: Exception
{
	public EOFException(string s): base(s){}
}

public class Vstup
{
	static string dek = null;
	static int index = 0;
	static int dlka = 0;

	private static void tidek()
	{
		dek = Console.ReadLine();
		if(dek == null) throw new EOFException("ten za koncem souboru.");
		index = 0;
		dlka = dek.Length;
	}

	private static void PeskoMezery()
	{
		while(index < dlka && dek[index] == ' ')
		{
			index++;
		}
	}

	private static string VraDalSlovo()
	{
		if(dek == null) tidek();
		PeskoMezery();
		while(index == dlka)
		{
			tidek();
			PeskoMezery();
		}
		StringBuilder slovo = new StringBuilder("");
		while(index < dlka && dek[index]!= ' ')
		{
			slovo.Append(dek[index++]);
		}
		return slovo.ToString();
	}
	
	// Pete a vrt etzec
	public static string tiString()
	{
		if(dek == null) tidek();
		StringBuilder etzec = new StringBuilder("");
		while(index < dlka)
		{
			etzec.Append(dek[index++]);
		}
		return etzec.ToString();
	}
	
	// Pete a vrt cel slo
	public static int tiInt()
	{
		return Convert.ToInt32(VraDalSlovo());
	}

	// Pete a vrt reln slo
	public static double tiDouble()
	{
		return Convert.ToDouble(VraDalSlovo());
	}
	public static bool ti(ref int x)
	{
		try 
		{
			x = tiInt();
			return true;
		}
		catch(EOFException e)
		{
			return false;
		}
	}
	public static bool ti(ref double x)
	{
		try 
		{
			x = tiDouble();
			return true;

		}
		catch(EOFException e)
		{
			return false;
		}
	}

}

