// Soubor BOD3.CS
// Ukazuje deklaraci a pouit udlost
// jako vlastnost

using System;

public delegate void NcoSeStalo(object zdroj, EventArgs e);

public class Bod
{
	private double x, y;
	private NcoSeStalo nss;				// Soukrom sloka pro ukldn handler
	public event NcoSeStalo ZmnaSouadnic
	{
		add{nss += value;}				// Pstupov metody
		remove{nss -= value; }
	}

	public Bod(double _x, double _y)			// Konstruktor
	{
		x = _x; y = _y; 
	}
	public double X						// Vlastnost X
	{
		set 
		{ 
			if(x != value)				// Pokud se opravdu mn 
			{					// souadnice x a je-li 
				x = value;			// registrovn njak
				if(nss != null)			// pedplatitel, spus udlost
					nss(this, new EventArgs());
			}
		}
		get { return x; }
	}
	public double Y								// Vlastnost Y
	{
		set 
		{ 
			if(y != value)						// Pokud se opravdu mn 
			{									// souadnice y a je-li 
				y = value;						// registrovn njak
				if(nss != null)		// pedplatitel, spus udlost
					nss(this, new EventArgs());
			}
		}
		get { return y; }
	}
	public double R								// Vzdlenost od plu
	{ 
		get { return Math.Sqrt(x*x+y*y); } 
	} 
		
	public double F							// Polrn hel
	{
		get { return Math.Atan2(y,x); }
	}
}

public class Obrzek
{
	public static void StaloSe(object o, EventArgs e)
	{	
		Console.WriteLine("Pekresluji");
	}
	public static void Main()					// Konstruktor se podstar
	{
		Bod B = new Bod(5,6);
		B.ZmnaSouadnic += new NcoSeStalo(StaloSe);
		B.X = 4.4; 								// Zpsob vznik udlosti
	}
}
