// Soubor VYP2.CS
// Ukazuje explicitn implementaci rozhran
// Tda Sestava je nyn odvozena od tdy ZkladnSestava,
// kter obsahuje metodu Vypi(), stejne jako rozhran IVypisovac.
// V metod Main() se vol metoda Vypi dvakrt: 
// Jednou prostednictvm odkazu na instanci, podruh
// prostednictvm odkazu na rozhran
using System;

public interface IVypisovac
{
	void Vypi();
}

public class Stav: IVypisovac
{
	public virtual void Vypi()
	{
		Console.WriteLine("Vypisuji stav ");
	}
} 


public class ZkladnSestava
{
	public void Vypi() 
	{
		Console.WriteLine("Vypisuji zkladn sestavu ");
	}
}
public class Sestava: ZkladnSestava, IVypisovac
{
	void IVypisovac.Vypi()
	{
		Console.WriteLine("Vypisuji sestavu pro rozhran");
	}
} 

public class Program
{
	public static void VypiTo(IVypisovac x)
	{
		x.Vypi();
	}
	
	public static void Main()
	{
		Sestava sest = new Sestava();
		Stav st = new Stav();
		sest.Vypi();						// Vol zddnou metodu 
		((IVypisovac)sest).Vypi();		// Vol explicitn implementovanou metodu
		VypiTo(st);			
		VypiTo(sest);						// Pouije explicitn implementovanou metodu
	}
}
