// Soubor Sestava.cs
// Ukazuje pekryt virtulnch metod z rozhran
// a jejich voln pomoc reference na pedka
// a reference na rozhran

using System;

public interface IVypisovac
{
	void Vypi();
}

public class Sestava: IVypisovac
{
	public virtual void Vypi()			// Implemementuje metodu jako virtuln
	{
		Console.WriteLine("Vypisuji sestavu pro rozhran");
	}
} 

public class KritickSestava: Sestava
{
	public override void Vypi() 		// Pekrv metodu rozhran implementovanou v pedkovi
	{
		Console.WriteLine("Vypisuji kritickou sestavu ");
	}
}

public class Program
{
	public static void Main()
	{
		// Dva odkazy na pedka, jeden obsahuje odkaz pedka, druh na potomka
		Sestava s = new KritickSestava();
		Sestava t = new Sestava();
		// Dva odkazy na rozhran, jeden obsahuje odkaz pedka, druh na potomka
		IVypisovac iv = s;
		IVypisovac iw = t;
		s.Vypi();		// Vol metodu pedka	
		t.Vypi();		// Vol metodu potomka
		iv.Vypi();		// Vol metodu pedka
		iw.Vypi();		// Vol metodu potomka
	}
}
