// Soubor VYJIM.CS
// Ukazuje pouit vlastnost StackTrace, Message a InnerException
//
// Tda Poty pot faktoril s kontrolou celoselnho peteen
// Tda Program obsahuej metodu bh, kter zavol Poty.f() 
// s pli velkm parametrem.
// Vzniklou vjimku zachyt a vyvol novou vjimku, kter ped zprvu
// "Nepovedlo se spotat faktoril"
// a pvodn vjimku jako "vnitn vjimku"
//
// Metoda Main() zachyt tuto vjimku, vype posloupnost voln a 
// zprvu ukloenou v aktuln vjimce a v jej vnitn vjimce
// Aby se vypisovaly pln cestu v Stacktrace, je teba peloit
// program pkazem
// csc /debug+ vyjim.cs

class Poty
{
	public static int f(int n)
	{
		int s = 1;
		checked{ 
			while(n>1) s *= n--;
		}
		return s;
	}
}

public class Program
{
	void Bh()
	{
		//System.Console.WriteLine(Poty.f(100));
		try 
		{
			System.Console.WriteLine(Poty.f(100));
		}
		catch(System.ArithmeticException ae)
		{
			throw new System.Exception("Nepovedlo se spotat faktoril", ae);
		}
	}
	public static void Main()
	{
		try
		{
			Program p = new Program();
			p.Bh();
		}
		catch(System.Exception e)
		{
			System.Console.WriteLine(e.StackTrace);
			System.Console.WriteLine(e.Message);
			if(e.InnerException != null){
				System.Console.WriteLine("Vnitn vjimka:");
				System.Console.WriteLine(e.InnerException.StackTrace);
				System.Console.WriteLine(e.InnerException.Message);
			}		
		}
	}
}