// Soubor Truefalse.cs
// pklad na peten opertor true a false
// Aby bylo mono instance rozumn pout v podmnkch ap., 
// je teba petit jet dal logick opertory
//
// Pklad pochz od D. Kame

using System;

namespace TFOperatorDemo
{
	public class MjDBBool
	{
		// Nastaven hodnot Nula, True a False pro tento typ
		public static readonly MjDBBool Nula = new MjDBBool(0);
		public static readonly MjDBBool False = new MjDBBool(-1);
		public static readonly MjDBBool True = new MjDBBool(1);

		private sbyte hodnota;

		// Konstruktor
		MjDBBool(int hodnota)
		{
			this.hodnota = (sbyte)hodnota;
		}

		// Jednoduch vlastnosti pro zjisteni hodnoty
		public bool JeNula{ get { return hodnota == 0; } }
		public bool JeFalse{ get { return hodnota < 0; } }
		public bool JeTrue{ get { return hodnota > 0; } }

		// Konverzn opertor bool->MjDBBool
		public static implicit operator MjDBBool(bool x)
		{
			return x ? True : False;
		}

		// Konverzn opertor  MjDBBool -> bool
		public static explicit operator bool(MjDBBool x)
		{
			if(x.hodnota == 0) throw new InvalidOperationException
								   ("Nelze provst konverzi MjDBBool na bool. MjDBBool==Null");
			return x.hodnota > 0;
		}

		// Opertory rovnosti a nerovnosti
		public static MjDBBool operator ==(MjDBBool x, MjDBBool y)
		{
			if(x.hodnota == 0 || y.hodnota == 0) return Nula;
			return x.hodnota == y.hodnota ? True : False;
		}

		public static MjDBBool operator !=(MjDBBool x, MjDBBool y)
		{
			if(x.hodnota == 0 || y.hodnota == 0) return Nula;
			return x.hodnota != y.hodnota ? True : False;
		}

		// Opertor negace
		public static MjDBBool operator !(MjDBBool x)
		{
			return new MjDBBool(-x.hodnota);
		}

		// Logick opertory AND a OR
		public static MjDBBool operator &(MjDBBool x, MjDBBool y)
		{
			return new MjDBBool(x.hodnota < y.hodnota ? 
				x.hodnota : y.hodnota);
		}

		public static MjDBBool operator |(MjDBBool x, MjDBBool y)
		{
			return new MjDBBool(x.hodnota > y.hodnota ? 
				x.hodnota : y.hodnota);
		}

		// Opertory true a false
		public static bool operator true(MjDBBool x)
		{
			return x.hodnota > 0;
		}

		public static bool operator false(MjDBBool x)
		{
			return x.hodnota < 0;
		}
	}

	class Program
	{
		// Analyzuje hodnotu tistavov promenne 
		private static void Analyzuj(MjDBBool b)
		{
			if(b)  // je TRUE ?
			{
				Console.WriteLine("Hodnota = True");
			}
			else if(!b) // je FALSE ?
			{
				Console.WriteLine("Hodnota = False");
			}
			else // je to Nula
			{
				Console.WriteLine("Hodnota = Nula");
			}
		}

		static void Main()
		{
			MjDBBool b = MjDBBool.True;
			Analyzuj(b);

			b = MjDBBool.False;
			Analyzuj(b);

			b = MjDBBool.Nula;
			Analyzuj(b);

			MjDBBool a = true;
			MjDBBool c;

			c = a && b;
			Analyzuj(c);

			c = a || b;
			Analyzuj(c);
		}
	}
}

