// Soubor HLEDEJ.CS
// Ukazuje pouit nstroj pro prci se soubory a adresi
// Program ekv jako parametr v pkazov dce jmno souboru
// a pokud na aktulnm disku existuje, vrt jeho plnou cestu
using System;
using System.IO;

class Vyhledva
{
	// Vlastn vyhledvn:
	// Nejprve se zept, zda soubor v danm adresi existuje (jmno si slo z adrese a jmna)
	// a pokud ne, prohled rekurzivn podadrese.
	static string NajdiVAdresi(string soubor, string adres)
	{
		string jmno = adres.EndsWith("\\")? adres+soubor : adres+"\\"+soubor;
		bool existuje = File.Exists(jmno);
		if(existuje) return jmno;
		else
		{
			string[] dir = Directory.GetDirectories(adres);
			foreach(string adr in dir)
			{
				string vsledek = NajdiVAdresi(soubor, adr);
				if(vsledek != null) return vsledek;
			}
			return null;
		}
	}
	
	static string Najdi(string jmno)	// Najdi soubor "jmno" a vra etzec pedstavujc jeho cestu
	{
		string dr = Directory.GetDirectoryRoot(Directory.GetCurrentDirectory());
		return NajdiVAdresi(jmno, dr);
	}
	static void Main(string[] args)
	{
		string s = Najdi(args[0]);
		Console.WriteLine(s != null ? s : "Soubor na tomto disku neexistuje");
	}
}
