// Soubor SEZNAM.CS
// Ukzka serializace objekt
// Tda Seznam implementuje jednosmrn zetzen seznam,
// nebo spe jeho zrodek. Obsahuje pouze metodu VloNaPotek()
// Obsahuje vnoenou tdu Prvek, kter obsahuje odkaz na dal prvek seznamu a 
// odkaz na uloen data.
// Uloen seznamu do souboru pedpokld, e se ulo vechny prvky, 
// spolu s jejich vzjemnmi vazbami prostednictvm odkaz.
// Tda Seznam, Prvek a ve, co do seznamu ulome, mus mt atribut Serializable,
// jinak vznikne vjimka

using System;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;

[Serializable]
public class Seznam
{
	[Serializable]
	internal class Prvek
	{
		object data = null;
		Prvek dal = null;
		public Prvek(){}
		public Prvek(object obj, Prvek dal){data = obj; dal = dal;}
		public Prvek Dal
		{
			set{dal = value;}
			get{return dal;}
		}
		public object Data
		{
			set{data = value;}
			get{return data;}
		}
	}

	Prvek hlava = null;
	Prvek konec = null;

	public void VloNaPotek(object obj)
	{
		hlava = new Prvek(obj, hlava);
		if(konec == null) konec = hlava;
	}

	public void Vypi(TextWriter tw)
	{
		Prvek p = hlava;
		while(p != null)
		{
			tw.WriteLine(p.Data);
			p = p.Dal;
		}
	}

	public void Ulo(string soubor)
	{
		FileStream fs = new FileStream(soubor, FileMode.Create);
		BinaryFormatter bf = new BinaryFormatter();
		bf.Serialize(fs, this);
		fs.Close();
	}

	public static void Nati(out Seznam s, string soubor)
	{
		FileStream fs = File.Open(soubor, FileMode.Open);
		BinaryFormatter bf = new BinaryFormatter();
		s = (Seznam)bf.Deserialize(fs);
		fs.Close();
	}
}

[Serializable] class X
{
	int i;
	public X(int ii){i = ii;}
	public override string ToString(){return "X: " + i;}
}

[Serializable] class Y
{
	X x;
	public Y(X ii){x = ii;}
	public override string ToString(){return "Y: " + x;}
}

class Program
{
	public static void Main()
	{
		X xx = new X(54);
		Seznam s = new Seznam();
		s.VloNaPotek(1);
		s.VloNaPotek(55);
		s.VloNaPotek(new Y(xx));
		s.VloNaPotek(new Y(xx));
		s.Vypi(Console.Out);
		s.Ulo("data.dta");
		s = null;
		Seznam.Nati(out s, "data.dta");
		s.Vypi(Console.Out);
	}
}